#include <gtk/gtk.h>

#include "boilerplate-application.h"
#include "boilerplate-window.h"
#include "boilerplate-preferences.h"

struct _BoilerplatePreferencesPrivate
{
    GSettings *settings;
};

G_DEFINE_TYPE_WITH_PRIVATE(BoilerplatePreferences, boilerplate_preferences, GTK_TYPE_DIALOG);

static void
boilerplate_preferences_init (BoilerplatePreferences *preferences)
{
    BoilerplatePreferencesPrivate *priv;

    priv = boilerplate_preferences_get_instance_private (preferences);
    gtk_widget_init_template (GTK_WIDGET (preferences));
    priv->settings = g_settings_new ("io.github.julianrichen.boilerplate");

    /*
    g_settings_bind (priv->settings, "font",
                     priv->font, "dark-theme",
                     G_SETTINGS_BIND_DEFAULT);
                     
    g_settings_bind (priv->settings, "transition",
                     priv->transition, "active-id",
                     G_SETTINGS_BIND_DEFAULT);
    */
}

static void
boilerplate_preferences_dispose (GObject *object)
{
    BoilerplatePreferencesPrivate *priv;

    priv = boilerplate_preferences_get_instance_private (BOILERPLATE_PREFERENCES (object));
    g_clear_object (&priv->settings);

    G_OBJECT_CLASS (boilerplate_preferences_parent_class)->dispose (object);
}

static void
boilerplate_preferences_class_init (BoilerplatePreferencesClass *class)
{
    G_OBJECT_CLASS (class)->dispose = boilerplate_preferences_dispose;

    gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (class),
                                               "/io/github/julianrichen/boilerplate/preferences.ui");
                                               
    /*
    gtk_widget_class_bind_template_child_private (GTK_WIDGET_CLASS (class), BoilerplatePreferences, font);
    gtk_widget_class_bind_template_child_private (GTK_WIDGET_CLASS (class), BoilerplatePreferences, transition);
    */
}

BoilerplatePreferences *
boilerplate_preferences_new (BoilerplateWindow *window)
{
    return g_object_new (BOILERPLATE_PREFERENCES_TYPE, "transient-for", window, "use-header-bar", TRUE, NULL);
}